#include "inkey.ch"
#include "common.ch"
#include "hbclass.ch"
*---------------------------------------------------*
CLASS DbfServer
*
Data alias      as String  Init ''
Data Shared     as Logic   Init .F.
Data aIndexes   as Array   Init {}
*
Method AddIndex(cIndexName,cKey,bKey,lUnique)
Method Append()
Method AppendDB(xFile)
Method AppendSDF(xFile)
Method ClearFilter()
Method ClearIndex()
Method Close()
Method Commit()
Method Continue()
Method CopyDB(xFile)
Method CopySDF(xFile)
Method CopyStructure(xFile)
Method CreateIndex(cIndexName,cKey,bKey,lUnique)
Method _Delete()
Method _Deleted()
Method _FieldGet(xField)
Method _FieldName(nField)
Method _FieldPos(cName)
Method _FieldPut(xField,xValue)
Method Skip(nSkip)
Method Filter()
Method _FLock()
Method GoBottom()
Method GoTo(nRec)
Method GoTop()
Method _IndexKey()
Method _IndexOrd()
Method Locate(bLock,bFor,bwhile,bNext,bRec,lRest)
Method New(cDbf,lShared,alias,cRDD)
Method Pack()
Method Recall()
Method RecallAll()
Method Reindex()
Method _RLock()
Method Seek(Exp,lSoftSeek)
Method _Select()
Method SetFilter(bCond,cCond)
Method SetIndex(cIndex)
Method SetOrder(nOrder)
Method Unlock()
Method Zap()
*
Method dbskip(nSkip)            INLINE ::Skip(nSkip)
Method dbGoBottom()             INLINE ::gobottom()
Method dbGoTo(nRec)             INLINE ::goto(nRec)
Method dbGoTop()                INLINE ::gotop()
Method Delete()                 INLINE ::_Delete()
Method Deleted()                INLINE ::_Deleted()
Method FieldGet(xField)         INLINE ::_FieldGet(xField)
Method FieldName(nField)        INLINE ::_FieldName(nField)
Method FieldPos()               INLINE ::_FieldPos(cName)
Method FieldPut(xField,xValue)  INLINE ::_FieldPut(xField,xValue)
Method FLock()                  INLINE ::_FLock()
Method IndexKey()               INLINE ::_IndexKey()
Method IndexOrd()               INLINE ::_IndexOrd()
Method RLock()                  INLINE ::_RLock()
Method Select()                 INLINE ::_Select()
Method OrdSetFocus(uOrd)        INLINE (::alias)->(OrdSetFocus(uOrd))
Method Found()                  INLINE (::alias)->(Found())
Method Recno()                  INLINE (::alias)->(Recno())
Method FCount()                 INLINE (::alias)->(FCount())
Method LastRec()                INLINE (::alias)->(LastRec())
Method DBStruct()               INLINE (::alias)->(DbStruct())
Method IndexExt()               INLINE (::alias)->(IndexExt())
Method Eof()                    INLINE (::alias)->(Eof())
Method Bof()                    INLINE (::alias)->(Bof())
*
ENDCLASS
*---------------------------------------------------*
*
Method New(cDbf,lShared,alias,cRDD) Class DbfServer
  *
  hb_Default(@lShared,FALSE)
  HB_Default(@alias  ,'DB'+strzero(Seconds(),5))
  HB_Default(@cRDD   ,'DBFCDX')
  *
  ::Shared     := lShared
  ::alias      := ""
  ::aIndexes   := {}
  *
  dbUseArea( .T.,cRDD,cDbf,alias,::Shared, .F. )
  ::alias   := alias()
  *
Return self
*---------------------------------------------------*
Method Close() Class DbfServer
  Local Zona := Select()
  *
  Select(::alias)
  dbclosearea(::alias)
  asize(::aIndexes,0)
  Select(Zona)
  *
Return self
*---------------------------------------------------*
Method Skip(nSkip) Class DbfServer
  hb_Default(@nSkip,1)
  (::alias)->(dbskip(nSkip))
Return self
*---------------------------------------------------*
Method GoTop() Class DbfServer
  ( ::alias )->(dbGoTop())
Return self
*---------------------------------------------------*
Method GoBottom() Class DbfServer
  (::alias)->(dbgoBottom())
Return self
*---------------------------------------------------*
Method GoTo(nRec) Class DbfServer
  (::alias)->(dbGoTo(nRec))
Return self
*---------------------------------------------------*
Method Seek(Exp,lSoftSeek) Class DbfServer
  *
  hb_Default(@lSoftSeek,FALSE)
  *
  (::alias)->(dbSeek(Exp,lSoftSeek))
  *
Return self
*---------------------------------------------------*
Method Unlock() Class DbfServer
  (::alias)->(dbUnLock())
Return self
*---------------------------------------------------*
Method _RLock() Class DbfServer
Return (::alias)->(RLock())
*---------------------------------------------------*
Method AppendDB(xFile) Class DbfServer
  (::alias)->(__dbApp(xFile))
Return self
*---------------------------------------------------*
Method AppendSDF(xFile) Class DbfServer
  (::alias)->(__dbSDF(xFile))
Return self
*---------------------------------------------------*
Method Append() Class DbfServer
  (::alias)->(dbAppend())
Return self
*---------------------------------------------------*
Method Commit() Class DbfServer
  (::alias)->(dbCommit())
Return self
*---------------------------------------------------*
Method SetIndex(cIndex) Class DbfServer
  (::alias)->(dbSetIndex(cIndex))
Return self
*---------------------------------------------------*
Method CreateIndex(cIndexName,cKey,bKey,lUnique) Class DbfServer
  *
  hb_Default(@lUnique,.F.)
  *
  (::alias)->(dbCreateIndex(cIndexName,cKey,bKey,lUnique))
  *
Return self
*---------------------------------------------------*
Method SetOrder(nOrder) Class DbfServer
  (::alias)->(dbSetOrder(nOrder))
Return self
*---------------------------------------------------*
Method CopyDB(xFile) Class DbfServer
  (::alias)->(__dbCopy(xFile))
Return self
*---------------------------------------------------*
Method CopySDF(xFile) Class DbfServer
  (::alias)->(__dbSDF(xFile))
Return self
*---------------------------------------------------*
Method Continue() Class DbfServer
  (::alias)->(__dbContinue())
Return self
*---------------------------------------------------*
Method CopyStructure(xFile) Class DbfServer
  (::alias)->(__dbCopyStruct(xFile))
Return self
*---------------------------------------------------*
Method _Delete() Class DbfServer
  (::alias)->(dbDelete())
Return self
*---------------------------------------------------*
Method _FieldName(nField) Class DbfServer
Return (::alias)->(FieldName(nField))
*---------------------------------------------------*
Method _FLock() Class DbfServer
Return (::alias)->(FLock())
*---------------------------------------------------*
Method Zap() Class DbfServer
  (::alias)->(__dbZap())
Return self
*---------------------------------------------------*
Method Recall() Class DbfServer
  Local xRet
  *
  If (::alias)->(RLock())
     (::alias)->(dbRecall())
     xRet := TRUE
  else
     xRET := FALSE
  Endif
  *
Return self
*---------------------------------------------------*
Method RecallAll() Class DbfServer
  Local xRet
  *
  If (::alias)->(FLock())
     (::alias)->(dbRecall())
     xRet := TRUE
  else
     xRet := FALSE
  Endif
  *
Return xRet
*---------------------------------------------------*
Method Pack() Class DbfServer
  *
  if (::alias)->(FLock())
     (::alias)->(__dbPack())
     (::alias)->(dbUnLock())
  Endif
  *
Return self
*---------------------------------------------------*
Method ClearFilter() Class DbfServer
  (::alias)->(dbClearFilter())
Return self
*---------------------------------------------------*
Method Locate(bLock,bFor,bwhile,bNext,bRec,lRest) Class DbfServer
  *
  hb_Default(@bFor   ,nil   )
  hb_Default(@bwhile ,nil   )
  hb_Default(@bNext  ,nil   )
  hb_Default(@bRec   ,nil   )
  hb_Default(@lRest  ,FALSE )
  *
  (::alias)->(__dbLocate( bLock, bfor, bwhile, bnext, bRec, lRest ))
  *
Return self
*---------------------------------------------------*
Method ClearIndex() Class DbfServer
  (::alias)->(dbClearIndex())
Return self
*---------------------------------------------------*
Method _FieldGet(xField) Class DbfServer
  if Valtype(xField) == 'C'
     xField := (::alias)->(FieldPos(xField))
  Endif
Return (::alias)->(FieldGet(xField))
*---------------------------------------------------*
Method _FieldPos(cName) Class DbfServer
Return  (::alias)->(FieldPos(Upper(cName)))
*---------------------------------------------------*
Method _FieldPut(xField,xValue) Class DbfServer
  *
  if Valtype(xField) == 'C'
     xField := (::alias)->(FieldPos(xField))
  Endif
  (::alias)->(FieldPut(xField,xValue))
  *
Return self
*---------------------------------------------------*
Method _Deleted() Class DbfServer
  Local xRet
  *
  if (::alias)->(deleted())
     xRet := TRUE
  else
     xRet := FALSE
  Endif
  *
Return xRet
*---------------------------------------------------*
Method _Select() Class DbfServer
  Select(::alias)
Return self
*---------------------------------------------------*
Method AddIndex(cIndexName,cKey,bKey,lUnique) Class DbfServer
  *
  hb_Default(@bKey   ,nil)
  hb_Default(@lUnique,.F.)
  *
  aadd(::aIndexes,{cIndexName,cKey,bKey,lUnique})
  *
Return self
*---------------------------------------------------*
Method ReIndex() Class DbfServer
  Local i
  *
  For i := 1 To Len(::aIndexes)
     (::alias)->(ordCondSet(,,,,,,(::alias)->(RecNo()),,,,,,,,,,,,,))
     (::alias)->(ordCreate(::aIndexes[i,1],::aIndexes[i,2],::aIndexes[i,2],::aIndexes[i,3],::aIndexes[i,4]))
  Next
  *
Return self
*---------------------------------------------------*
Method _IndexKey(nOrder) Class DbfServer
  hb_Default(@nOrder,IndexOrd())
Return (::alias)->(IndexKey(nOrder))
*---------------------------------------------------*
Method _IndexOrd() Class DbfServer
Return (::alias)->(IndexOrd())
*
Method SetFilter(bCond,cCond) Class DbfServer
  (::alias)->(dbSetFilter(bCond,cCond))
Return self
*---------------------------------------------------*
Method Filter() Class DbfServer
Return (::alias)->(dbFilter())
